AC_DEFUN(AC_PROG_YACC_NO_MINUS_Y,
[AC_CHECK_PROGS(YACC, 'bison' byacc, yacc)])


AC_DEFUN(AC_CXX_HAVE_STL,
[AC_CACHE_CHECK(whether the compiler supports Standard Template Library,
ac_cv_cxx_have_stl,
[AC_REQUIRE([AC_CXX_NAMESPACES])
 AC_LANG_SAVE
 AC_LANG_CPLUSPLUS
 AC_TRY_COMPILE([#include <list>
#include <deque>
#ifdef HAVE_NAMESPACES
using namespace std;
#endif],[list<int> x; x.push_back(5);
list<int>::iterator iter = x.begin(); if (iter != x.end()) ++iter; return 0;],
 ac_cv_cxx_have_stl=yes, ac_cv_cxx_have_stl=no)
 AC_LANG_RESTORE
])
if test "$ac_cv_cxx_have_stl" = yes; then
  AC_DEFINE(HAVE_STL,,[define if the compiler supports Standard Template Library])
else
  AC_MSG_ERROR([Cokokola requires the Standard Template Library - upgrade your C++ compiler package])
fi
])

AC_DEFUN(AC_CXX_HAVE_STL_M_VARS,
[AC_CACHE_CHECK(whether STL uses _M_ variables or not,
ac_cv_cxx_have_stl_m_vars,
[AC_LANG_SAVE
 AC_LANG_CPLUSPLUS
 AC_TRY_COMPILE([#include <vector.h>
#include <string.h>],[
class string : public vector<char> {
public:
        string() : vector<char>() {}
        string& operator=(const char* first) {
                 reserve(strlen(first)+1);
                 _M_finish = copy(first, first + strlen(first) + 1, _M_start);
                 return *this;
        }
};],ac_cv_cxx_have_stl_m_vars=yes, ac_cv_cxx_have_stl_m_vars=no)
 AC_LANG_RESTORE
])
if test "$ac_cv_cxx_have_stl_m_vars" = yes; then
 AC_DEFINE(HAVE_STL_M_VARS,,[define if stl uses _M_ variables])
fi
])


AC_DEFUN(AC_CXX_NAMESPACES,
[AC_CACHE_CHECK(whether the compiler implements namespaces,
ac_cv_cxx_namespaces,
[AC_LANG_SAVE
 AC_LANG_CPLUSPLUS
 AC_TRY_COMPILE([namespace Outer { namespace Inner { int i = 0; }}],
                [using namespace Outer::Inner; return i;],
 ac_cv_cxx_namespaces=yes, ac_cv_cxx_namespaces=no)
 AC_LANG_RESTORE
])
if test "$ac_cv_cxx_namespaces" = yes; then
  AC_DEFINE(HAVE_NAMESPACES,,[define if the compiler implements namespaces])
fi
])

