TRANSFORMATION PD2

 -- Auxiliary transformation called directly by FKAux, 
 -- indirectly by FactorK.  This transformation specifically
 -- simplifies compositions of UNNEST and UNNEST

 USES
 
		ru0:  f o id --> f,

        ru1a: UNNEST (f o #2, g) o UNNEST (h1, h2)			               --> UNNEST (f o #2, id) o UNNEST (g o h1, h2),
        ru1b: UNNEST (#2, g) o UNNEST (h1, h2)			                   --> UNNEST (#2, id) o UNNEST (g o h1, h2),

        ru2a: UNNEST (f o #2 o SHR, g o #2) o UNNEST (h1, h2)			   --> UNNEST (f, g) o UNNEST (#2 o h1, h2),
        ru2b: UNNEST (#2 o SHR, g o #2) o UNNEST (h1, h2)				   --> UNNEST (id, g) o UNNEST (#2 o h1, h2),

        ru3a: UNNEST (f o #2 o SHR, K (B)) o UNNEST (h1, h2)			   --> UNNEST (f, K (B)) o UNNEST (#2 o h1, h2),
        ru3b: UNNEST (#2 o SHR, K (B)) o UNNEST (h1, h2)				   --> UNNEST (id, K (B)) o UNNEST (#2 o h1, h2),

        ru4a: UNNEST (f o SHR o SHR, g o SHR) o UNNEST (h1, h2)			   --> UNNEST (f o <#1, SHR o #2> o SHR, g) o UNNEST (SHR o h1, h2),
        ru4b: UNNEST (SHR o SHR, g o SHR) o UNNEST (h1, h2)				   --> UNNEST (<#1, SHR o #2> o SHR, g) o UNNEST (SHR o h1, h2),

        ru5a: UNNEST (f o #2 o SHR, g o SHR) o UNNEST (h1, h2)			   --> UNNEST (f o #2 o SHL o <#1, SHR o #2> o SHR, g) o UNNEST (SHR o h1, h2),
        ru5b: UNNEST (#2 o SHR, g o SHR) o UNNEST (h1, h2)				   --> UNNEST (#2 o SHL o <#1, SHR o #2> o SHR, g) o UNNEST (SHR o h1, h2),

        ru6a: UNNEST (f o <#1, SHR o #2> o SHR, g o SHR) o UNNEST (h1, h2) --> UNNEST (f o <#1, SHR o #2> o SHL o <#1, SHR o #2> o SHR, g) o UNNEST (SHR o h1, h2),
        ru6b: UNNEST (<#1, SHR o #2> o SHR, g o SHR) o UNNEST (h1, h2)	   --> UNNEST (<#1, SHR o #2> o SHL o <#1, SHR o #2> o SHR, g) o UNNEST (SHR o h1, h2),

        ru7a: UNNEST (f o SHR o SHR, K (B)) o UNNEST (h1, h2)			   --> UNNEST (f o <#1, SHR o #2> o SHR, K (B)) o UNNEST (SHR o h1, h2),
        ru7b: UNNEST (SHR o SHR, K (B)) o UNNEST (h1, h2)				   --> UNNEST (<#1, SHR o #2> o SHR, K (B)) o UNNEST (SHR o h1, h2),

        ru8a: UNNEST (f o SHR o SHR, g o #2) o UNNEST (h1, h2)			   --> UNNEST (f o <#1, SHR o #2> o SHR, g o #2 o #2) o UNNEST (SHR o h1, h2),
        ru8b: UNNEST (SHR o SHR, g o #2) o UNNEST (h1, h2)				   --> UNNEST (<#1, SHR o #2> o SHR, g o #2 o #2) o UNNEST (SHR o h1, h2),

        PullP2SHRF

 BEGIN   
   {{{ru1a || {GIVEN UNNEST (#2, id) o _F DO SKIP} || ru1b || ru2a || ru2b || ru3a || ru3b} -> {GIVEN _F o UNNEST (f, _F) DO ru0 (f)}} ||
	{{ru4a || ru4b || ru5a || ru5b || ru6a || ru6b || ru7a || ru7b || ru8a || ru8b} -> {GIVEN UNNEST (f o SHR, _F) o UNNEST (g, _F) DO {ru0 (g); PullP2SHRF (f)}; PD2}}
   }
 END
