//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek)                                             
//  FILE: PCMulStmtDis.C
//  PROJ: COKO
//  DATE: 8/27/96                                                              
//
// SYNOPSIS
//  Method definitions for CMulStmtDis class.
//  
//////////////////////////////////////////////////////////////////////////////
#include <assert.h>
#include "PCState.H"
#include "PCStmt.H"
#include "PCMulStmtDis.H"


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CMulStmtDis
// Parameters:	(CStmt *first, CStmt *second)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CMulStmtDis::CMulStmtDis(CStmt *first, CStmt *second)
{
  _first = first;
  _second = second;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CMulStmtDis
// Parameters:	(void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CMulStmtDis::~CMulStmtDis(void)
{
  if(_first) { delete _first; _first = NULL; }
  if(_second) { delete _second; _second = NULL; }
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters:	(CState*)
//
// What to do when executed.
//         								    
//////////////////////////////////////////////////////////////////////////////

CState *CMulStmtDis::Exec(CState *s)
{

if (_debug_)
  cout << "-- MulStmtDis Begins" << endl;

  // First, execute the former statements.
  s = _first->Exec(s);

  if(s->ISuccess() == F) {
	// If the all of the statements failed, do the next statement.
	s = _second->Exec(s);
  }

if (_debug_)
  cout << "-- MulStmtDis Ends" << endl;

  return s;
}


