//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek)                                             
//  FILE: PCMulStmtSeq.C
//  PROJ: COKO
//  DATE: 8/27/96                                                              
//
// SYNOPSIS
//  Method definitions for CMulStmtSeq class.
//  
//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include "PCState.H"
#include "PCStmt.H"
#include "PCMulStmtSeq.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CMulStmtSeq
// Parameters:	(CStmt *first, CStmt *second)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CMulStmtSeq::CMulStmtSeq(CStmt *first, CStmt *second)
{
  _first = first;
  _second = second;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CMulStmtSeq
// Parameters:	(void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CMulStmtSeq::~CMulStmtSeq(void)
{
  if (_first) { delete _first; _first = NULL; }
  if (_second) { delete _second; _second = NULL; }
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters:	(CState*)
//
// What to do when executed.
//         								    
//////////////////////////////////////////////////////////////////////////////

CState *CMulStmtSeq::Exec(CState *s)
{
  if(_debug_)
	cout << "-- MulStmtSeq Begins" << endl;

  s = _first->Exec(s);   // Execute the former statement(s) first.
  int success = s->ISuccess();
  s = _second->Exec(s);  // Then execute the next statement.

  s->SetSuccess(s->ISuccess() || success);
  // The MulStmtSeq is true when either _first or _second succeed

  if(_debug_)
	cout << "-- MulStmtSeq Ends" << endl;


  return s;
}



