//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek)                                             
//  FILE: PCMulStmtSeq.H
//  PROJ: COKO
//  DATE: 8/27/96                                                              
//
// SYNOPSIS
//  Class definition for CMulStmtSeq class.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCMULSTMTSEQ_H_
#define _PCMULSTMTSEQ_H_

#include <PCStmt.H>

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CMulStmtSeq
//
// SYNOPSIS
//  This class is a derived class from CStmt. It is used for multiple 
//  statements connected by sequential execution semantics in COKO rule block.
//
//////////////////////////////////////////////////////////////////////////////

class CMulStmtSeq : public CStmt
{
protected:
  CStmt *_first;                  // Former statement(s)
  CStmt *_second;                 // Later statement
public:
  CMulStmtSeq(CStmt *, CStmt *);  // Constructor
  ~CMulStmtSeq(void);             // Destructor
  CState *Exec(CState *);         // What to do when executed

};

#endif
