//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl@cs.brown.edu)
//  FILE: PCTrueStmt.C
//  PROJ: COKO
//  DATE: 6/10/97                                                              
//
// SYNOPSIS
//  Class definition for CTrueStmt class.
//  
//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include "PCState.H"
#include "PCStmt.H"
#include "PCTrueStmt.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CTrueStmt
// Parameters: (CStmt*)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CTrueStmt::CTrueStmt(CStmt* stmt)
{
  _stmt = stmt;
}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CTrueStmt
// Parameters: (void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CTrueStmt::~CTrueStmt(void)
{
  if(_stmt) { delete _stmt; _stmt = NULL;}
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Exec
// Parameters: (CState*)
//
// What to do when executed
// Execute _stmt then set _Success to true.
//
//////////////////////////////////////////////////////////////////////////////

CState* CTrueStmt::Exec(CState *s)
{
  s = _stmt->Exec(s);

  // set _Success to True 
  s->SetSuccess(T);

  return s;
}
