/*
 * Copyright 1995, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *      Name:
 *      Organization:
 *      Address (postal and/or electronic):
 *
 * To:
 *      Software Librarian
 *      Computer Science Department, Box 1910
 *      Brown University
 *      Providence, RI 02912
 *
 *              or
 *
 *      brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
*/

   
/*
//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc@cs.brown.edu)					 	    
//  FILE: KOLA.y
//  PROJ: KOLA parser and Tree Generator 
//  DATE: 5/95		                                                    
//
//////////////////////////////////////////////////////////////////////////////
*/

%token <sval> IDENT INTCON STRINGCON FLOATCON
%token COMMENT OPREFIX FPREFIX PPREFIX EMPTY XTIMES TIMES IF FTHEN ELSE TRUEV FALSEV UNION INTER MULT INV
%token FINV ID ONE TWO SET SINGLETON FLATTEN CHOOSE CIRC NIL ITERATE ITER PCON PFOLD
%token PLUS CON CONST CURRY BOR BAND NOT LE GE NE EX FA TID
%token FOLD UNI INT DIF JOIN MOD ABS SHIFTL SHIFTR
%token NJOIN UNNEST PEQUAL LESS OPLUS GREATER FI FINVOKE PINVOKE FADD FSUB FMUL FDIV
%token EXISTS FORALL MINUS DIV ERROR BPREFIX LANGLE RANGLE FAVG FSUM FCOUNT FMIN FMAX PLEX
%token SORT INS LSJOIN RSJOIN DPO DPC KSTRING KFLOAT KCHAR OID ODIF


%right FINVOKE PINVOKE
%left '-' '+' ODIF
%left '*' '/'
%left UNION INTER XTIMES TIMES PLUS MINUS CIRC OPLUS '&' '|' 
%left BOR BAND
%left FINV
%left PEQUAL LESS GREATER LE GE NE

%{
#include "KGlobals.H"
#include "KOFMod.H" 
#include "KOFAbs.H"
#include "KOFInverse.H"
#include "KOBAnd.H"
#include "KOBNotEqual.H"
#include "KOBEqu.H"
#include "KOBGE.H"
#include "KOBGT.H"
#include "KOBInvoke.H"
#include "KOBLE.H"
#include "KOBLT.H"
#include "KOBName.H"
#include "KOBNot.H"
#include "KOBOr.H"
#include "KOBPrimitive.H"
#include "KOBool.H"
#include "KOFShiftL.H"
#include "KOFShiftR.H"
#include "KOFAvg.H"
#include "KOFSum.H"
#include "KOFMin.H"
#include "KOFMax.H"
#include "KOFCount.H"
#include "KOPLex.H"
#include "KOFAdd.H"
#include "KOFMinus.H"
#include "KOFMult.H"
#include "KOFDiv.H"
#include "KOF1.H"
#include "KOF2.H"
#include "KOFPFold.H"
#include "KOFCElt.H"
#include "KOFChoose.H"
#include "KOFCompose.H"
#include "KOFCon.H"
#include "KOFConst.H"
#include "KOFDif.H"
#include "KOFFlatten.H"
#include "KOFFold.H"
#include "KOFTID.H"
#include "KOFID.H"
#include "KOFIterate.H"
#include "KOFIter.H"
#include "KOFInt.H"
#include "KOFJoin.H"
#include "KOFNJoin.H"
#include "KOFPlus.H"
#include "KOFSet.H"
#include "KOFSingleton.H"
#include "KOFTimes.H"
#include "KOFUni.H"
#include "KOFUnnest.H"
#include "KOFUser.H"
#include "KOFunction.H"
#include "KOOMinus.H"
#include "KONonType.H"
#include "KOOFloat.H"
#include "KOODif.H"
#include "KOODiv.H"
#include "KOOIf.H"
#include "KOOInt.H"
#include "KOOAny.H"
#include "KOOInter.H"
#include "KOOInvoke.H"
#include "KOOLink.H"
#include "KOOMult.H"
#include "KOOName.H"
#include "KOOPair.H"
#include "KOOPlus.H"
#include "KOOSet.H"
#include "KOOStr.H"
#include "KOOTimes.H"
#include "KOOUni.H"
#include "KOObjList.H"
#include "KOObject.H"
#include "KOPCEX.H" // token EX
#include "KOPCElt.H"
#include "KOPCFA.H" // token FA
#include "KOPCombine.H"
#include "KOPConjunct.H"
#include "KOPConst.H"
#include "KOPDisjunct.H"
#include "KOPEqual.H"
#include "KOPGreater.H"
#include "KOPLess.H"
#include "KOPGreaterEqual.H"
#include "KOPLessEqual.H"
#include "KOPNotEqual.H"
#include "KOPExists.H"
#include "KOPForall.H"
#include "KOPInv.H"
#include "KOPLess.H"
#include "KOPNegate.H"
#include "KOPTimes.H"
#include "KOPUser.H"
#include "KOPredicate.H"
#include "KOFPCon.H"
#include "KOFSort.H"
#include "KOFIns.H"
#include "KOFLSJoin.H"
#include "KOFRSJoin.H"
#include "KOOMod.H"
#include "KOOId.H"

#include "TYTBool.H"
#include "TYTFunc.H"
#include "TYTInt.H"
#include "TYTObj.H"
#include "TYTPair.H"
#include "TYTPred.H"
#include "TYTSet.H"
#include "TYTBag.H"
#include "TYTFlt.H"
#include "TYTStr.H"
#include "TYTChar.H"
#include "TYTVar.H"
#include "TYType.H"
#include "TYTUser.H"

#include "ENEnvironment.H"
#include <iostream.h>
#include <string.h>

#include "result.H"

extern int lineno;


extern char *Kolatext;
extern int Kolalex ();
int Kolaerror(char*); 

// extern NonType *result;

PUser *PUserRule (char *s, TObj* ty) {

  TPred* ptyp = new TPred(ty);
  PUser *res = new PUser (s, ptyp);
  delete [] s;
  return res;

}

FUser *FUserRule (char *s, TObj* ty1, TObj* ty2) {

  TFunc *ftyp = new TFunc(ty1,ty2);
  FUser *res = new FUser (s,ftyp);
  delete [] s;
  return res;

}

/*
IUser *IUserRule (char *s) {

  IUser *res = new IUser (s);
  delete [] s;
  return res;

}
*/

TUser *TUserRule (char *s) {

  TUser *res = new TUser (s);
  delete [] s;
  return res;

}

OName *ONameRule (char *s) {

  OName *res = new OName (s);
  delete [] s;
  return res;

}

OName *ONameRule_DB (char *s, char *s2) {

  OName *res = new OName (s, s2);
  delete [] s;
  return res;

}

BName *BNameRule (char *s) {

  BName *res = new BName (s);
  delete [] s;
  return res;

}


%}

%union {
  class NonType *start;
  class koObject *obj;
  class Function *fun;
  class Predicate *pre;
  class koBool *boo;
  class TObj *typ;
  class ObjList *ol;
  char *sval;

}


%type <start> S
%type <obj> E Term Fact 
%type <fun> Func
%type <pre> Pred
%type <typ> kType

%type <boo> BoolE BoolCon
%type <ol> EList NEEList

%start S


%%

S               :  Comment E
                
                    {result = $2;}

                |  Comment BoolE
		    
                    {result = $2;}

                ;


Comment 	    :  COMMENT Comment

                |

                ;

E		        :  IDENT 
			      
  			        {$$ = ONameRule ($1);}

                |  EMPTY

                    {$$ = new OSet (NULL);}
			      
                | '{' EList '}'

                    {$$ = new OSet ($2);}

                |  E UNION E

                    {$$ = new OUni ($1, $3);}

                |  E INTER E

                    {$$ = new OInter ($1, $3);}

                |  E ODIF E

                    {$$ = new ODif ($1, $3);}

                |  E TIMES E

                    {$$ = new OTimes ($1, $3);}


                |  '[' E ',' E ']'

                    {$$ = new OPair ($2, $4);}

                |  IF BoolE FTHEN E ELSE E FI

                    {$$ = new OIf ($2, $4, $6);}

                |  Func FINVOKE E

                    {$$ = new OInvoke ($1, $3);}
                
                |  E PLUS Term
	                    
                    {$$ = new OPlus ($1, $3);}
                
                |  E MINUS Term
		                    
                    {$$ = new OMinus ($1, $3);}

                |  Term

                    {$$ = $1;}

                ;

EList		    :    NEEList
                    
                    {$$ = $1;}        

                |                         

                    {$$ = new ObjList ();}        

                ;


NEEList         :   NEEList ',' E

			        {
					  $1 -> insert ($3);
					  $$ = $1;
					}

                |  E

                    {
					  ObjList *ol = new ObjList ();
					  ol -> insert ($1);
					  $$ = ol;
					}

		        ;

BoolE           :  Pred PINVOKE E

			        {$$ = new BInvoke ($1, $3);}

                |  E PEQUAL E

                    {$$ = new BEqu ($1, $3);}

                |  E NE E

                    {$$ = new BNotEqual ($1, $3);}

                |  E LESS E

                    {$$ = new BLT ($1, $3);}

                |  E LANGLE E

                    {$$ = new BLT ($1, $3);}

                |  E LE E

                    {$$ = new BLE ($1, $3);}

                |  E GREATER E

                    {$$ = new BGT ($1, $3);}

                |  E RANGLE E

                    {$$ = new BGT ($1, $3);}

                |  E GE E

                    {$$ = new BGE ($1, $3);}
                
                |  BoolE BAND BoolE
	                    
                    {$$ = new BAnd ($1, $3);}
		
                |  BoolE BOR BoolE

                    {$$ = new BOr ($1, $3);}

                |  NOT '(' BoolE ')'

                    {$$ = new BNot ($3);}

                |  '(' BoolE ')'

                    {$$ = $2;}

                |  BoolCon

                    {$$ = $1;}

                |  BPREFIX '(' IDENT ')'

                    {$$ = BNameRule ($3);}

 		        ;  

BoolCon		    :  TRUEV

			        {$$ = new BPrimitive (T);}

                |  FALSEV

                    {$$ = new BPrimitive (F);}

                ;

Func            :  ID
                      
			        {$$ = new FID ();}
                    
                |  TID

                    {$$ = new FTID ();}
                
                |  SHIFTL

                    {$$ = new FShiftL ();}
                
                |  SHIFTR

                    {$$ = new FShiftR ();}
                
                |  ONE

                    {$$ = new F1 ();}
                
                |  TWO
				                      
                    {$$ = new F2 ();}

                |  FADD

                    {$$ = new FAdd ();}

                |  FSUB

                    {$$ = new FMinus ();}

                |  FMUL

                    {$$ = new FMult ();}

                |  FDIV

                    {$$ = new FDiv ();}

                |  FAVG
                    {$$ = new FAvg ();}

		|  FSUM
		    {$$ = new FSum ();}

		| FCOUNT
		    {$$ = new FCount ();}

		| FMIN
		    {$$ = new FMin ();}

		| FMAX
		    {$$ = new FMax ();}

                |  MOD

                    {$$ = new FMod ();}

                |  ABS

                    {$$ = new FAbs ();}

                |  INV

                    {$$ = new FInverse ();}

                |  SET

                    {$$ = new FSet ();}

                |  SINGLETON

 	                {$$ = new FSingleton();}
                    
                |  FLATTEN

                    {$$ = new FFlatten ();}

                |  CHOOSE

                    {$$ = new FChoose ();}

                |  INS

                    {$$ = new FIns ();}

          		|  FPREFIX '(' IDENT ',' kType ',' kType ')' 

                    {$$ = FUserRule ($3, $5, $7);}

                |  Func CIRC Func

                    {$$ = new FCompose ($1, $3);}

                |  Func XTIMES Func

                    {$$ = new FTimes ($1, $3);}

                |  Func TIMES Func

                    {$$ = new FTimes ($1, $3);}

                |  Func PLUS Func

                    {$$ = new FPlus ($1, $3);}

                |  LANGLE Func ',' Func RANGLE

                    {$$ = new FPlus ($2, $4);}

                |  CON '(' Pred ',' Func ',' Func ')'

                    {$$ = new FCon ($3, $5, $7);}
	
                |  CONST '(' E ')'

                    {$$ = new FConst ($3);}

                |  CURRY '(' Func ',' E ')'

                    {$$ = new FCElt ($3, $5);}

                |  ITERATE '(' Pred ',' Func ')'

                    {$$ = new FIterate ($3, $5);}

                |  ITER '(' Pred ',' Func ')'

                    {$$ = new FIter ($3, $5);}

                |  PCON '(' Pred ',' Func ')'
					                
	                {$$ = new FPCon ($3, $5);}
                    
                |  PFOLD '(' Func ',' Func ')'

                    {$$ = new FPFold ($3, $5);}

                |  FOLD '(' E ',' Func ',' Func ')'

                    {$$ = new FFold ($3, $5, $7);}

                |  UNI '(' Pred ')'

                    {$$ = new FUni ($3);}

                |  INT '(' Pred ')'

                    {$$ = new FInt ($3);}

                |  DIF '(' Pred ')'

                    {$$ = new FDif ($3);}

                |  SORT '(' Pred ')'

                    {$$ = new FSort ($3);}

                |  JOIN '(' Pred ',' Func ')'

                    {$$ = new FJoin ($3, $5);}

                |  RSJOIN '(' Pred ',' Func ')'

                    {$$ = new FRSJoin ($3, $5);}

                |  LSJOIN '(' Pred ',' Func ')'

                    {$$ = new FLSJoin ($3, $5);}

                |  NJOIN '(' Pred ',' Func ',' Func ')'
 
                    {$$ = new FNJoin ($3, $5, $7);}

                |  UNNEST '(' Func ',' Func ')'

                    {$$ = new FUnnest ($3, $5);}

                |  '(' Func ')'

                    {$$ = $2;}

                ;

Pred            :  PEQUAL
                    
			        {$$ = new PEqual ();}

                |  LESS

                    {$$ = new PLess ();}

                |  LANGLE

                    {$$ = new PLess ();}

                |  GREATER

                    {$$ = new PGreater ();}

                |  RANGLE

                    {$$ = new PGreater ();}

                |  LE

                    {$$ = new PLessEqual ();}

                |  GE

                    {$$ = new PGreaterEqual ();}

                |  NE

                    {$$ = new PNotEqual ();}

                |  NOT '(' Pred ')'

                    {$$ = new PNegate ($3);}

                |  PPREFIX '(' IDENT ',' kType ')'

                    {$$ = PUserRule ($3, $5);}

                |  Pred '&' Pred

                    {$$ = new PConjunct ($1, $3);}

                |  Pred '|' Pred

                    {$$ = new PDisjunct ($1, $3);}

                |  Pred OPLUS Func

                    {$$ = new PCombine ($1, $3);}

                |  Pred FINV

                    {$$ = new PInv ($1);}

                |  Pred TIMES Pred

                    {$$ = new PTimes ($1, $3);}

                |  Pred XTIMES Pred

                    {$$ = new PTimes ($1, $3);}

                |  CURRY '(' Pred ',' E ')'

                    {$$ = new PCElt ($3, $5);}

                |  CONST '(' BoolE ')'

                    {$$ = new PConst ($3);}

                |  EXISTS '(' Pred ')'

                    {$$ = new PExists ($3);}

                |  FORALL '(' Pred ')'

                    {$$ = new PForall ($3);}

                |  EX '(' Pred ')'

                    {$$ = new PCEX ($3);}

                |  FA '(' Pred ')'

                    {$$ = new PCFA ($3);}

		| PLEX '(' Pred ',' Pred ')'
		    {$$ = new PLex ($3, $5);}		

                |  '(' Pred ')'

                    {$$ = $2;}

                ;

kType           :  IDENT

                    {$$ = TUserRule($1);}

                |  '[' kType ',' kType ']'

                    {$$ = new TPair($2, $4);}

                |  '{' kType '}'
  
                    {$$ = new TSet($2);}

                |  DPO kType DPC

                    {$$ = new TBag($2); }

                |  INT

                    {$$ = new TInt();}

                |  KFLOAT

                    {$$ = new TFlt();}

                |  KSTRING

                    {$$ = new TStr();}

                |  KCHAR

                    {$$ = new TChar();}

                ;


Term            :  Term MULT Fact

			         {$$ = new OMult ($1, $3);}

                |  Term DIV Fact

                    {$$ = new ODiv ($1, $3);}

                |  Term MOD Fact

                    {$$ = new OMod ($1, $3);}

                |  Fact

                    {$$ = $1;}
			
                ;


Fact            :  INTCON  
                    
                    { char* tmp_char = $1; $$ = new OInt ($1); delete tmp_char;}

                |  OID  '(' INTCON ')'  

                    { $$ = new OId ($3);}

                |  STRINGCON 

                    { char* tmp_char = $1; $$ = new OStr ($1); delete tmp_char;}

                |  FLOATCON

                    { char* tmp_char = $1; $$ = new OFloat ($1); delete tmp_char;}

                |  OPREFIX '(' IDENT ')'

                    {$$ = ONameRule ($3);}

                |  OPREFIX '(' IDENT ',' IDENT ')'

                    {$$ = ONameRule_DB ($3, $5);}

                |  NIL

                    {$$ = new OAny ();}
		    
                | '(' E ')'

				    {$$ = $2;}
                    
                ;


%%

int Kolaerror (char *s)  {

  cerr <<  s << " found at line: " << lineno << " (" << Kolatext << ")" << " of KOLA Query.\n\n";
  return 0;
}












